<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>LibGirl 兌換</title>
    <style>
        .center {
            margin: auto;
            width: 50%;
            padding: 20px;
            text-align: center;
            font-size: 20px;
        }

        input, button {
            font-size: 20px;
        }

        #coupon_title {
            color: darkred;
        }

        #coupon_info {
            text-align: left;
            border: 1px solid indianred;
            padding: 10px;
        }

        #form {
            padding: 20px;
        }

        #result {
            color: red;
            border: 1px solid indianred;
            display: none;
        }
    </style>
</head>
<body>
<div class="center">
    <div id="coupon">
        <div>
            <h3 id="coupon_title"></h3>
            <div id="coupon_info"></div>
        </div>
        <div id="form">
            店家認證碼：<input id="password" required type="password">
            <button id="submit">送出</button>
        </div>
    </div>
    <div>
        <h3 id="result"></h3>
    </div>
</div>
<script src="https://unpkg.com/axios/dist/axios.min.js"></script>
<script>
  const passwordDom = document.getElementById('password');
  const submitButton = document.getElementById('submit');
  const couponDom = document.getElementById('coupon');
  const couponTitleDom = document.getElementById('coupon_title');
  const couponInfoDom = document.getElementById('coupon_info');
  const resultDom = document.getElementById('result');
  const formDom = document.getElementById('form');
  const queryString = window.location.search;
  const urlParams = new URLSearchParams(queryString);

  const userId = urlParams.get('id');
  const event = urlParams.get('event');
  const serial = urlParams.get('serial');
  const token = urlParams.get('token');

  let waiting = false;

  function redeemCoupon() {
    if (waiting) {
      return;
    }
    waiting = true;
    callApi(redeemSuccess, showError, { action: 'REDEEM' });
  }

  function redeemSuccess(response) {
    formDom.remove();
    showResult(response.data.message);
  }

  function showError(e) {
    const errorMessage = e.response.data.message || '抱歉，出錯囉～';
    if (e.response.status === 401) {
      alert(errorMessage);
      return;
    }
    showResult(errorMessage);
    couponDom.remove();
  }

  function checkSuccessHandler(response) {
    const data = response.data.data;
    couponTitleDom.innerText = data.title;
    couponInfoDom.innerText = data.info;
  }

  function callApi(successCallback, errorCallback, optionalData) {
    axios.post('https://qxi7wjof68.execute-api.us-east-1.amazonaws.com/production/libgirl/coupon', {
      userId, event, serial, token, password: passwordDom.value, ...optionalData,
    }).then(successCallback)
      .catch(errorCallback)
      .finally(function () {
        waiting = false;
      });
  }

  function showResult(errorMessage) {
    resultDom.innerText = errorMessage;
    resultDom.style.display = 'block';
  }

  submitButton.addEventListener('click', redeemCoupon);

  passwordDom.addEventListener('keyup', function (event) {
    if (event.key === 'Enter') {
      event.preventDefault();
      redeemCoupon();
    }
  });

  callApi(checkSuccessHandler, showError);
</script>
</body>
</html>
